import utilsPM.*;
import tadsPM.*;

class IO
{


  private InOut io;

  public IO ()
  {
    io = new InOut ();
  };


  public void escriu_enter (int n) throws Exception
  {
    io.writeln (n);
  }

  public void escriu (String text) throws Exception
  {
    io.write (text);
  }
  public int llegir_enter () throws Exception
  {
    int n;
      n = io.readint ();
      return n;
  }

  public Soterrani llegir_soterrani () throws Exception
  {
    Soterrani s = new Soterrani ();

      s.estructura = leer_arbol_int (0, io);

      return s;
  }


  public Guarnicio llegir_guarnicio () throws Exception
  {

    Guarnicio temp = new Guarnicio ();

    int n = io.readint ();
    int i;
    int par1, par2, par3;
    for (i = 0; i < n; i++)
      {
	// sala_in, bandol (1M 2G), qualitat

	par1 = io.readint ();
	par2 = io.readint ();
	par3 = io.readint ();


//      io.writeln("-------"+i+"-"+par1+"-"+par2+"-"+par3+"-------");
	temp.accedeix (i, par1, par2, par3);
	temp.suma1 ();

      }

    return temp;

  }
  public void escriure_onades (Onades o) throws Exception
  {
    int i;

    for (i = 0; i < o.quantes (); i++)
      {
	// núm Bàndol
	io.write (o.lleg_num (i));
	io.write (' ');
	io.write (o.lleg_band (i));
	io.write ('\n');
      }
  }


  public Arbol leer_arbol_int (int marca, InOut io) throws Exception
    /* Lee el arbol en preorden: primero la raiz y luego,
       recursivamente, los hijos izquierdo y derecho.
       Las marcas ocupan el papel del arbol nulo */
    /* Ejemplo: el arbol 

       1
       /   \
       2     3

       se lee 1 2 0 0 3 0 0 (o con los numeros en distintas lineas) */
  {
    Arbol b, c;

    int x = io.readint ();
    Integer wx = new Integer (x);

    if (x != marca)
      {
	b = leer_arbol_int (marca, io);	// hijo izquierdo
	c = leer_arbol_int (marca, io);	// hijo derecho
	b.plantar (wx, c);
      }
    else
      {
	b = new Arbol ();
	b.a_nulo ();
      }

    return b;

  }



}
